'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
var React = require('react');
var ReactDOM = require('react-dom');
var classnames = require('classnames');
var utilsCommons = require('@highlight-ui/utils-commons');
function _interopDefaultLegacy(e) {
  return e && typeof e === 'object' && 'default' in e ? e : {
    'default': e
  };
}
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var ReactDOM__default = /*#__PURE__*/_interopDefaultLegacy(ReactDOM);
var classnames__default = /*#__PURE__*/_interopDefaultLegacy(classnames);

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function () {
  __assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
function __rest(s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
}
var styles$1 = {
  "drawerContainer": "Drawer-module__RvA2hNuK__v5-3-46",
  "backdropContainer": "Drawer-module__XquV4QyS__v5-3-46"
};
var Drawer = function (_a) {
  var _b = _a.enableBackdrop,
    enableBackdrop = _b === void 0 ? false : _b,
    _c = _a.visible,
    visible = _c === void 0 ? false : _c,
    _d = _a.disabledBodyScrolling,
    disabledBodyScrolling = _d === void 0 ? true : _d,
    _e = _a.preventToClose,
    preventToClose = _e === void 0 ? false : _e,
    _f = _a.closeKey,
    closeKey = _f === void 0 ? 'Escape' : _f,
    _g = _a.topOffset,
    topOffset = _g === void 0 ? '0px' : _g,
    _h = _a.leftOffset,
    leftOffset = _h === void 0 ? '280px' : _h,
    _j = _a.drawerClassName,
    drawerClassName = _j === void 0 ? null : _j,
    _k = _a.className,
    className = _k === void 0 ? null : _k,
    _l = _a.backdropClassName,
    backdropClassName = _l === void 0 ? null : _l,
    children = _a.children,
    _m = _a.onOpen,
    onOpen = _m === void 0 ? utilsCommons.noop : _m,
    _o = _a.onClose,
    onClose = _o === void 0 ? utilsCommons.noop : _o,
    _p = _a.onRequestToClose,
    onRequestToClose = _p === void 0 ? utilsCommons.noop : _p,
    _q = _a.onBackdropClick,
    onBackdropClick = _q === void 0 ? utilsCommons.noop : _q,
    metadata = _a.metadata,
    remainingProps = __rest(_a, ["enableBackdrop", "visible", "disabledBodyScrolling", "preventToClose", "closeKey", "topOffset", "leftOffset", "drawerClassName", "className", "backdropClassName", "children", "onOpen", "onClose", "onRequestToClose", "onBackdropClick", "metadata"]);
  var initialBodyOverflowYValueRef = React.useRef(window.document.body.style.overflowY);
  var prevPropVisible = React.useRef(visible);
  var ref = React.useRef(null);
  var determineBodyOverflowStyle = React.useCallback(function () {
    /**
     * Set overflow hidden in order to prevent body scrolling while
     * the full modal is opened
     */
    if (disabledBodyScrolling) {
      window.document.body.style.overflowY = visible ? 'hidden' : initialBodyOverflowYValueRef.current;
    }
  }, [disabledBodyScrolling, visible]);
  var handleKeyDown = React.useCallback(function (event) {
    var closeKeyWasPressed = String(event.key) === String(closeKey);
    if (closeKeyWasPressed && !preventToClose) {
      onRequestToClose();
    }
  }, [closeKey, onRequestToClose, preventToClose]);
  React.useEffect(function () {
    if (visible) {
      document.addEventListener('keydown', handleKeyDown);
    } else {
      document.removeEventListener('keydown', handleKeyDown);
    }
    determineBodyOverflowStyle();
    var overflowY = initialBodyOverflowYValueRef.current;
    return function () {
      document.removeEventListener('keydown', handleKeyDown);
      window.document.body.style.overflowY = overflowY;
    };
  }, [determineBodyOverflowStyle, handleKeyDown, visible]);
  React.useEffect(function () {
    if (visible !== prevPropVisible.current) {
      prevPropVisible.current = visible;
      // Prop callbacks
      if (visible) {
        onOpen();
      } else {
        onClose();
      }
      determineBodyOverflowStyle();
      // Add / Remove event for closing using keyboard
      if (visible) {
        document.addEventListener('keydown', handleKeyDown);
      } else {
        document.removeEventListener('keydown', handleKeyDown);
      }
    }
    return function () {
      document.removeEventListener('keydown', handleKeyDown);
    };
  }, [determineBodyOverflowStyle, handleKeyDown, onClose, onOpen, visible]);
  var backdropSizeStyle = {
    top: topOffset,
    height: "calc(100% - " + topOffset + ")"
  };
  var sizeStyle = __assign(__assign({}, backdropSizeStyle), {
    left: leftOffset,
    width: "calc(100% - " + leftOffset + ")"
  });
  var containerClassName = classnames__default["default"](styles$1.drawerContainer, drawerClassName || className);
  var Component = React__default["default"].createElement(React__default["default"].Fragment, null, visible && enableBackdrop && React__default["default"].createElement("div", {
    className: classnames__default["default"](styles$1.backdropContainer, backdropClassName),
    style: backdropSizeStyle,
    onClick: function () {
      return !preventToClose && onBackdropClick();
    },
    role: "presentation"
  }), React__default["default"].createElement("div", __assign({}, remainingProps, utilsCommons.parseMetadata(metadata), {
    className: containerClassName,
    style: sizeStyle,
    "data-state": visible && 'show',
    ref: ref,
    role: "dialog",
    "aria-hidden": !visible,
    "aria-modal": visible || undefined
  }), children));
  return ReactDOM__default["default"].createPortal(Component, window.document.body);
};
var DrawerBody = React__default["default"].forwardRef(function (_a, ref) {
  var className = _a.className,
    children = _a.children,
    metadata = _a.metadata;
  return React__default["default"].createElement("div", __assign({}, utilsCommons.parseMetadata(metadata), {
    className: classnames__default["default"](className),
    ref: ref
  }), children);
});
var DrawerBody$1 = React__default["default"].memo(DrawerBody);
var styles = {
  "drawerHeaderContainer": "DrawerHeader-module__-Vdd-yhE__v5-3-46",
  "drawerHeaderContainerFixed": "DrawerHeader-module__bB6Zvpd0__v5-3-46",
  "drawerHeaderContainerFixedWithScroll": "DrawerHeader-module__iidEID3H__v5-3-46"
};
var DrawerHeader = function (_a) {
  var _b;
  var _c = _a.fixed,
    fixed = _c === void 0 ? false : _c,
    className = _a.className,
    children = _a.children,
    metadata = _a.metadata;
  var prevPropFixed = React.useRef(fixed);
  var ref = React.useRef(null);
  var onScroll = React.useCallback(function (event) {
    var _a = event.currentTarget.scrollTop,
      scrollTop = _a === void 0 ? 0 : _a;
    var appendFixedClass = scrollTop !== 0;
    if (ref.current) {
      ref.current.classList[appendFixedClass ? 'add' : 'remove'](styles.drawerHeaderContainerFixedWithScroll);
    }
  }, []);
  React.useEffect(function () {
    var _a;
    if (ref.current || prevPropFixed.current !== fixed) {
      var parentEl = (_a = ref.current) === null || _a === void 0 ? void 0 : _a.parentElement;
      // Make sure just to add the event if is the drawer element
      var drawerEl = parentEl && parentEl.getAttribute('role') === 'dialog' ? parentEl : null;
      if (!drawerEl) {
        return;
      }
      if (fixed) {
        drawerEl.addEventListener('scroll', onScroll);
      } else {
        drawerEl.removeEventListener('scroll', onScroll);
      }
    }
    prevPropFixed.current = fixed;
  }, [ref, fixed, onScroll]);
  var containerClassName = classnames__default["default"]((_b = {}, _b[styles.drawerHeaderContainerFixed] = fixed, _b), styles.drawerHeaderContainer, className);
  return React__default["default"].createElement("div", __assign({}, utilsCommons.parseMetadata(metadata), {
    className: containerClassName,
    ref: ref
  }), children);
};
exports.Drawer = Drawer;
exports.DrawerBody = DrawerBody$1;
exports.DrawerHeader = DrawerHeader;
//# sourceMappingURL=index.js.map
